Rem ------------------------------------------------------------------
Action base class, used for spells
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Type TAction
	Field figure:TFigure
	Method Use(pFigure:TFigure)
	
	End Method
	Method Hit(pFigure:TFigure)
	
	End Method
End Type

Type TActionAttack Extends TAction
	Method Use(pFigure:TFigure)
		figure = pFigure
		New TProjectile.Init(Self, figure, figure.posx, figure.posy, figure.rotation, figure.radius +3, 10, COL_ATTACK)
	End Method
	Method Hit(pFigure:TFigure)
		pFigure.health :- DAMAGE_ATTACK
	End Method
End Type

Type TActionHeavy Extends TAction
	Method Use(pFigure:TFigure)
		figure = pFigure
		New TProjectile.Init(Self, figure, figure.posx, figure.posy, figure.rotation, figure.radius +3, 5, COL_HEAVY)
	End Method
	Method Hit(pFigure:TFigure)
		pFigure.health :- DAMAGE_HEAVY
	End Method
End Type

Type TActionBomb Extends TAction
	Method Use(pFigure:TFigure)
		figure = pFigure
		New TProjectile.Init(Self, figure, figure.posx, figure.posy, figure.rotation, figure.radius +3, 10, COL_BOMB)
	End Method
	Method Hit(pFigure:TFigure)
		For Local fig:TFigure = EachIn TFigure.list
			If fig <> player then
				' check distance to hit figure
				Local dx:Float, dy:Float
				Local dist:Float
				dx = fig.posx -pFigure.posx
				dy = fig.posy -pFigure.posy
				dist = sqr(dx*dx +dy*dy)
				' within range, hurt
				If dist <= 100 then
					fig.health :- DAMAGE_BOMB
					' visual fx
					For Local i:Int = 0 Until 20
						Local a:Int = Rand(0,359)
						Local r:Float = Rnd(0.2,1)
						New TParticle.Init(fig.posx, fig.posy, cos(a)*r, sin(a)*r, Rnd(0.5, 1), COL_BOMB, Rand(400,600))
					Next
				EndIf
			EndIf
		Next
	End Method
End Type

Type TActionFreeze Extends TAction
	Method Use(pFigure:TFigure)
		figure = pFigure
		New TProjectile.Init(Self, figure, figure.posx, figure.posy, figure.rotation, figure.radius +3, 20, COL_FREEZE)
	End Method
	Method Hit(pFigure:TFigure)
		pFigure.buff = BUFF_FREEZE
	End Method
End Type

Type TActionWeaken Extends TAction
	Method Use(pFigure:TFigure)
		figure = pFigure
		New TProjectile.Init(Self, figure, figure.posx, figure.posy, figure.rotation, figure.radius +3, 20, COL_WEAKEN)
	End Method
	Method Hit(pFigure:TFigure)
		pFigure.buff = BUFF_WEAK
	End Method
End Type

Type TActionHeal Extends TAction
	Method Use(pFigure:TFigure)
		pFigure.health = Min(pFigure.healthmax, pFigure.health +RESTORE_HEAL)
		' visual fx
		For Local i:Int = 0 Until 10
			Local a:Int = Rand(0,359)
			Local r:Float = Rnd(0.5,2)
			New TParticle.Init(pFigure.posx, pFigure.posy, cos(a)*r, sin(a)*r, Rnd(1,2), COL_HEAL, 200)
		Next
	End Method
End Type

Type TActionManareg Extends TAction
	Method Use(pFigure:TFigure)
		pFigure.mana = Min(pFigure.manamax, pFigure.mana +RESTORE_MANA)
		' visual fx
		For Local i:Int = 0 Until 10
			Local a:Int = Rand(0,359)
			Local r:Float = Rnd(0.5,2)
			New TParticle.Init(pFigure.posx, pFigure.posy, cos(a)*r, sin(a)*r, Rnd(1,2), COL_MANAREG, 200)
		Next
	End Method
End Type

Type TActionDebuff Extends TAction
	Method Use(pFigure:TFigure)
		pFigure.buff = BUFF_NONE
		' visual fx
		For Local i:Int = 0 Until 10
			Local a:Int = Rand(0,359)
			Local r:Float = Rnd(0.5,2)
			New TParticle.Init(pFigure.posx, pFigure.posy, cos(a)*r, sin(a)*r, Rnd(1,2), COL_DEBUFF, 200)
		Next
	End Method
End Type
