Rem ------------------------------------------------------------------
Figure spawn point for enemies, will count figures alive whithin area
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Type TFigSpawnpoint
	Global list:TList = CreateList()

	Field posx:Int, posy:Int
	Field radius:Int
	Field count:Int, maxcount:Int
	Field spawns:TFigureAI[]
	Field nexttime:Int
	Field skin:Int, settings:Int[]
	
	Method Init:TFigSpawnpoint(pSkin:Int, pSettings:Int[], pX:Int, pY:Int, pRadius:Int, pMaxCount:Int)
		skin		= pSkin
		settings	= pSettings
		posx		= pX
		posy		= pY
		radius		= pRadius
		maxcount	= pMaxCount
		spawns		= New TFigureAI[maxcount]
		list.AddLast(Self)
		Return Self
	End Method
	
	Function SpawnAll(pIgnoreTimer:Int=False)
		For Local s:TFigSpawnpoint = EachIn list
			s.Spawn(pIgnoreTimer)
		Next
	End Function
	
	Method Spawn(pIgnoreTimer:Int)
		Local x:Int, y:Int, dir:Int, dist:Int, free:Int
		Local dx:Int, dy:Int, d:Int
		While count < maxcount
			If pIgnoreTimer=False And nexttime>ms then
				Return
			EndIf
			dir = Rand(0,359)
			dist = Rand(0,radius)
			x = posx +cos(dir) *dist
			y = posy +sin(dir) *dist
			' check if position is free
			free = True
			For Local fig:TFigure = EachIn TFigure.list
				dx = x -fig.posx
				dy = y -fig.posy
				d = sqr(dx*dx +dy*dy)
				If d < fig.radius*2 then
					free = False
					Exit
				EndIf
			Next
			' spawn
			If free then
				Local fig:TFigureAI = New TFigureAI
				fig.Init(skin, settings, x,y)
				fig.rotation = Rand(0, 359)
				fig.spawnpoint = Self
				spawns[count] = fig
				nexttime :+ 2000
				count :+ 1
			EndIf
		Wend
		nexttime = ms +RESPAWN_TIME
	End Method
End Type