Rem ------------------------------------------------------------------
Particles for visual fx
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Type TParticle
	Global list:TList = CreateList()
	Field posx:Float, posy:Float
	Field vx:Float, vy:Float
	Field scale:Float
	Field color:Int[], alpha:Float
	Field lifetime:Int, endtime:Int
	
	Method Init:TParticle(pX:Float, pY:Float, pVX:Float, pVY:Float, pScale:Float, pCol:Int[], pLifetime:Int, pAlpha:Float=1)
		posx		= pX
		posy		= pY
		vx			= pVX
		vy			= pVY
		scale		= pScale
		color		= pCol
		alpha		= pAlpha
		lifetime	= pLifetime
		endtime		= ms +lifetime
		list.AddLast(Self)
		Return Self
	End Method
	
	Function UpdateAll()
		For Local part:TParticle = EachIn list
			part.Update()
		Next
	End Function
	
	Method Update()
		If ms > endtime then
			list.Remove(Self)
			Return
		EndIf
		posx :+ vx
		posy :+ vy
	End Method
	
	Function DrawAll()
		For Local part:TParticle = EachIn list
			part.Draw()
		Next
	End Function
	
	Method Draw()
		Local time:Int = endtime -ms
		Local a:Float = time / Float(lifetime)
		SetBlend(LIGHTBLEND)
		SetAlpha(a *alpha)
		SetColor(color[0], color[1], color[2])
		SetScale(scale,scale)
		DrawImage(imgFlare, posx, posy)
		SetScale(1,1)
	End Method
End Type