Rem ------------------------------------------------------------------
Constants for project
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const SCREEN_WIDTH:Int		= 1024
Const SCREEN_HEIGHT:Int		= 768

Const MAP_BORDER_LF:Int		= 48
Const MAP_BORDER_TP:Int		= 48
Const MAP_BORDER_RT:Int		= 976 -1
Const MAP_BORDER_BT:Int		= 592 -1

Const STATE_MENU:Int		= 0
Const STATE_GAME:Int		= 1
Const STATE_GAMEOVER:Int	= 2

Const BUTTON_WIDTH:Int		= 512
Const BUTTON_HEIGHT:Int		= 64

' icon frames
Const ICON_ATTACK:Int		= 0
Const ICON_BOMB:Int			= 1
Const ICON_FREEZE:Int		= 2
Const ICON_HEAVY:Int		= 3
Const ICON_WEAKEN:Int		= 4
Const ICON_HEAL:Int			= 5
Const ICON_MANAREG:Int		= 6
Const ICON_DEBUFF:Int		= 7
Const ICON_FROZEN:Int		= 8
Const ICON_WEAK:Int			= 9

Const ICONSTATE_AVAILABLE:Int	= 0
Const ICONSTATE_ENERGY:Int		= 1
Const ICONSTATE_MANA:Int		= 2

' figure frames
Const FIGURE_PLAYER:Int			= 0
Const FIGURE_ENEMY:Int			= 1
Const FIGURE_BOSS:Int			= 2

Const BUFF_NONE:Int			= 0
Const BUFF_FREEZE:Int		= 1
Const BUFF_WEAK:Int			= 2

' gameplay settings
Const DAMAGE_ATTACK:Int		= 30000
Const DAMAGE_HEAVY:Int		= 500000
Const DAMAGE_BOMB:Int		= 20000
Const RESTORE_HEAL:Int		= 400000
Const RESTORE_MANA:Int		= 400000

Const FIG_SPEED_NORMAL:Float	= 1
Const FIG_SPEED_BACK:Float		= 0.7
'Const FIG_SPEED_LATERAL:Float	= 0.6
'Const FIG_SPEED_FORLAT:Float	= 0.82 ' v_des / SQR(v_n^2 +v_l^2), v_des = 0.95
'Const FIG_SPEED_BACKLAT:Float	= 0.71 ' v_des / SQR(v_b^2 +v_l^2), v_des = 0.75

Const DIFFICULTIES_CNT:Int				= 3
Global DIFFICULTIES_IDLE:Int[]			= [10000, 1000, 100]
Global DIFFICULTIES_CAPTIONS:String[]	= ["leicht", "mittel", "schwer"]

Const CONTROL_ABSOLUTE:Int			= 0
Const CONTROL_RELATIVE:Int			= 1
Global CONTROLS_CAPTIONS:String[]	= ["absolut", "relativ"]

Const RESPAWN_TIME:Int			= 30000

' player settings
Global FIG_PLR_SETTINGS:Int[]	= [8, 200, 1000000, 100, 1000000, 500, 1000000, 10000, 5, 5, 5]
Global FIG_ENY_SETTINGS:Int[]	= [10, 200, 50000, 100, 1000000, 500, 1000000, 5000, 1, 2, 3]
Global FIG_BOS_SETTINGS:Int[]	= [16, 200, 3000000, 100, 1000000, 500, 1000000, 10000, 5, 10, 20]

' light engine
Const SCALE_SHADOW:Float		= 1.02
Const SCALE_LIGHT:Float			= 0.9995
Global LIGHT_COL_AMBIENT:Int[]	= [$60, $60, $60]

' colors
Global COL_ATTACK:Int[]		= [$ff, $80, $00]
Global COL_HEAVY:Int[]		= [$ff, $00, $20]
Global COL_BOMB:Int[]		= [$ff, $20, $00]
Global COL_FREEZE:Int[]		= [$00, $cc, $ff]
Global COL_WEAKEN:Int[]		= [$80, $ff, $00]
Global COL_HEAL:Int[]		= [$00, $ff, $00]
Global COL_MANAREG:Int[]	= [$00, $60, $ff]
Global COL_DEBUFF:Int[]		= [$ff, $ff, $00]
Global COL_POINTER:Int[]	= [$00, $ff, $ff]

' loot
Const DROP_HEAL:Int			= 0
Const DROP_MANA:Int			= 1
Const DROP_DEBUFF:Int		= 2
Const DROP_RADIUS:Int		= 8
Global DROP_COLORS:Int[][]	= [COL_HEAL, COL_MANAREG, COL_DEBUFF]

' spells
Const TT_ATTACK:String		= "Einfache Attacke, fgt geringen Schaden zu."
Const TT_HEAVY:String		= "Schwere Attacke, fgt grossen Schaden zu."
Const TT_BOMB:String		= "Fgt dem getroffenen Ziel und den Figuren in der Nhe Schaden zu."
Const TT_FREEZE:String		= "Friert das Ziel ein, so dass es sich nicht mehr bewegen kann."
Const TT_WEAKEN:String		= "Schwcht das Ziel, so dass seine Energie langsamer regeneriert."
Const TT_HEAL:String		= "Heilt den Spieler."
Const TT_MANAREG:String		= "Stellt Manapunkte wieder her."
Const TT_DEBUFF:String		= "Befreit den Spieler von Schwchungs-Zaubern."

Global SPELL_ATTACK:TSpell		= New TSpell.Init(ICON_ATTACK,	New TActionAttack,	TT_ATTACK,	100000,  250000)
Global SPELL_HEAVY:TSpell		= New TSpell.Init(ICON_HEAVY,	New TActionHeavy,	TT_HEAVY,	500000, 1000000)
Global SPELL_BOMB:TSpell		= New TSpell.Init(ICON_BOMB,	New TActionBomb,	TT_BOMB,	400000,  250000)
Global SPELL_FREEZE:TSpell		= New TSpell.Init(ICON_FREEZE,	New TActionFreeze,	TT_FREEZE,	300000,  500000)
Global SPELL_WEAKEN:TSpell		= New TSpell.Init(ICON_WEAKEN,	New TActionWeaken,	TT_WEAKEN,	300000,  500000)
Global SPELL_HEAL:TSpell		= New TSpell.Init(ICON_HEAL,	New TActionHeal,	TT_HEAL,	 00000,  250000, 0)
Global SPELL_MANAREG:TSpell		= New TSpell.Init(ICON_MANAREG,	New TActionManareg,	TT_MANAREG,	 00000,  250000, 1)
Global SPELL_DEBUFF:TSpell		= New TSpell.Init(ICON_DEBUFF,	New TActionDebuff,	TT_DEBUFF,	 00000,   50000, 2)

Global SPELLS:TSpell[]	= [SPELL_ATTACK, SPELL_HEAVY, SPELL_FREEZE, SPELL_WEAKEN, SPELL_BOMB, SPELL_HEAL, SPELL_MANAREG, SPELL_DEBUFF]
Global SPELLS_HOTKEYS:Int[]				= [KEY_1, KEY_2, KEY_3, KEY_4, KEY_5, KEY_E, KEY_R, KEY_F]
Global SPELLS_HOTKEYS_CAPTIONS:String[] = ["1", "2", "3", "4", "5", "E", "R", "F"]

' game over texts
Const GOT_WON:String		= "Du hast den Boss besiegt und das Spiel gewonnen!"
Const GOT_LOST:String		= "Du hast leider verloren."
